
#include <stdlib.h>

#include <math.h>

#include <iostream>
#include <fstream>

#include <string.h>

using namespace std;


inline int Char2Index( char c )
{
  switch( c )
  {
    case 'A':
    case 'a':
      return( 0 );
    case 'C':
    case 'c':
      return( 1 );
    case 'G':
    case 'g':
      return( 2 );
    case 'T':
    case 't':
      return( 3 );
    default:
      double d = rand() / (double)RAND_MAX;
      return( (int)floor( d * 4 ) );
  }
}

inline int R( int i )
{
  return( 3 - i ); // trick~ 
}


typedef unsigned int uint;


uint* f0;
uint** f1;
uint*** f2;
uint**** f3;


const double eps = 1E-4;


inline void PrintLine( ofstream& o, uint* line )
{
  int sum = 0;
  double P[4];
  int zeros = 0;

  for( int i=0; i<4; i++ )
  {
    if( line[i] == 0 )
      zeros++;
    sum += line[i];
  }

  for( int i=0; i<4; i++ )
  {
    if( line[i] == 0 )
      P[i] = eps;
    else
      P[i] = (double)line[i]/sum - eps*zeros;
  }

  for( int i=0; i<3; i++ )
    o << P[i] << " ";
  o << P[3] << endl;
}

void PrintBG( char* bgfile )
{
  ofstream of( bgfile, ios::trunc );

  PrintLine( of, f0 );

  for( int i=0; i<4; i++ )
    PrintLine( of, f1[i] );

  for( int i=0; i<4; i++ )
    for( int j=0; j<4; j++ )
      PrintLine( of, f2[i][j] );

  for( int i=0; i<4; i++ )
    for( int j=0; j<4; j++ )
      for( int k=0; k<4; k++ )
        PrintLine( of, f3[i][j][k] );

  of.close();
}


int main( int argn, char** argv )
{
  // initialize
  srand( 1029 );
  
  
  f0 = new uint[4];
  memset( f0, 0, sizeof(uint)*4 );

  f1 = new uint*[4];
  f2 = new uint**[4];
  f3 = new uint***[4];

  for( int i=0; i<4; i++ )
  {
    f1[i] = new uint[4];
    memset( f1[i], 0, sizeof(uint)*4 );

    f2[i] = new uint*[4];
    f3[i] = new uint**[4];

    for( int j=0; j<4; j++ )
    {
      f2[i][j] = new uint[4];
      memset( f2[i][j], 0, sizeof(uint)*4 );

      f3[i][j] = new uint*[4];
    
      for( int k=0; k<4; k++ )
      {
        f3[i][j][k] = new uint[4];
        memset( f3[i][j][k], 0, sizeof(uint)*4 );
      }
    }
  }




///////
  char *seqfile = argv[1];
  
  const int SEQ_MAX = 100000;
  
  char* seq = new char[SEQ_MAX];
  int* seq_index = new int[SEQ_MAX];

  ifstream f;
  f.open( seqfile,ios::in );
  
  f.getline( seq, SEQ_MAX );
  f.getline( seq, SEQ_MAX );
  
  int L = strlen( seq );
  for( int i=0; i < L; i++ )
  {
//    cout << seq[i] << " " << Char2Index(seq[i]) << endl;
    seq_index[i] = Char2Index(seq[i]);
  }

  for( int i=0; i < L; i++ )
  {
    f0[ seq_index[i] ]++;
    f0[ R(seq_index[(L-1)-i]) ]++;

    if( i < L-1 )
    {
      f1[   seq_index[i] ][          seq_index[i+1] ]++;
      f1[ R(seq_index[(L-1)-i]) ][ R(seq_index[(L-1)-(i+1)]) ]++;

      if( i < L-2 )
      {
        f2[   seq_index[i] ][          seq_index[i+1] ][            seq_index[i+2] ]++;
        f2[ R(seq_index[(L-1)-i]) ][ R(seq_index[(L-1)-(i+1)]) ][ R(seq_index[(L-1)-(i+2)]) ]++;
     
        if( i < L-3 )
        {
          f3[   seq_index[i] ][          seq_index[i+1] ][            seq_index[i+2] ][            seq_index[i+3] ]++;
          f3[ R(seq_index[(L-1)-i]) ][ R(seq_index[(L-1)-(i+1)]) ][ R(seq_index[(L-1)-(i+2)]) ][ R(seq_index[(L-1)-(i+3)]) ]++;
        }
      }
    }
  }


  delete[] seq;

  f.close();
  
  PrintBG( argv[2] );

}


