#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <fstream>
#include <iostream>

using namespace std;

main(int argc, char** argv  )
{
  char *pssmfile = argv[1];
  char *paramfile = argv[2];

    // read in the matrix file
    ifstream ifp1;
    ifp1.open(pssmfile,ios::in);

    if(!ifp1.is_open()) {
      printf("can't open %s\n", pssmfile);
      exit(1);
    }

    int maxScore;
    int lengthOfMotif;

    ifp1 >> maxScore;
    ifp1 >> lengthOfMotif;


    // read in the parameters file

   double array1[4][maxScore+1];
   double array2[4][maxScore+1];
   double trans[4][4];
   double station[4];

   ifstream ifp2;
   float tempf;
   char temps[200];
   ifp2.open(paramfile,ios::in);

   if(!ifp2.is_open()) {
    printf("can't open %s\n", paramfile);
    exit(1);
   }

  // stationary
  for(int i=0; i<4; i++) {
    ifp2 >> tempf;
    station[i] = tempf;
  }

  // first-order
  for(int i=0; i<4; i++) {
    for(int k=0; k<4; k++) {
      ifp2 >> tempf;
      trans[k][i] = tempf;
    }
  }

   int max1 = 0;
   int max2 = 0;

   int temp1;
   int temp2;
   int temp3;
   int weight[4][lengthOfMotif];

   for(int j=0; j<lengthOfMotif; j++)
     for(int i=0; i<4; i++)
       ifp1 >> weight[i][j];

   // algorithm!
  for(int i=0; i<4; i++)
    for(int j=0; j<maxScore +1 ; j++) {
      array1[i][j] = 0.0;
      array2[i][j] = 0.0;
    }

  for(int i=0; i<4; i++) {
	    array1[i][0] = station[i];
  }

  for(int p=0; p<lengthOfMotif;p++){
    for(int i=0; i<4; i++) { // over vector
      for(int j=0; j < 4; j++)
	  for(int k=0; k<(max1+1); k++) {
	     temp3 = k + weight[i][p];
	     if(temp3 > max2)
	        max2 = temp3;
	        array2[i][temp3] = array2[i][temp3]
	        + array1[j][k] * trans[i][j];
	  }
    }

    for(int i=0; i<4; i++)
      for(int j=0; j<maxScore + 1; j++) {
   		array1[i][j] = array2[i][j];
		array2[i][j] = 0.0;
	  }

    max1 = max2;
  }

  for(int j=0; j<max1+1; j++) {
    for(int i=0;i<4; i++)
      array2[0][j] = array2[0][j] + array1[i][j];
  }

  double dis = 0.0;
  for(int i=max1; i>=0; i--) {
	 dis = dis + array2[0][i];
         cout << i << '\t' << array2[0][i] << '\t' << dis << endl;
  }

  ifp1.close();
  ifp2.close();

  exit(0);
}





