#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <fstream>
#include <iostream>

using namespace std;

main(int argc, char** argv  )
{
  char *pssmfile = argv[1];
  char *paramfile = argv[2];

    // read in the matrix file
    ifstream ifp1;
    ifp1.open(pssmfile,ios::in);

    if(!ifp1.is_open()) {
      printf("can't open %s\n", pssmfile);
      exit(1);
    }

    int maxScore;
    int lengthOfMotif;

    ifp1 >> maxScore;
    ifp1 >> lengthOfMotif;

    //printf("length of motif = %i\n",lengthOfMotif);

    // read in the parameters file
    //printf("reading parameters file %s...\n",paramfile);



   double array1[64][maxScore+1];
   double array2[64][maxScore+1];
   double trans[4][64];
   double station[4];
   double first[16];

   ifstream ifp2;
   float tempf;
   char temps[200];
   ifp2.open(paramfile,ios::in);

   if(!ifp2.is_open()) {
    printf("can't open %s\n", paramfile);
    exit(1);
   }

  // stationary
  for(int i=0; i<4; i++) {
    ifp2 >> tempf;
    station[i] = tempf;
    //    printf("read %3.2f\n",station[i]);
  }

  // first-order
  for(int i=0; i<4; i++) {
    for(int k=0; k<4; k++) {
      ifp2 >> tempf;
      first[i*4+k] = tempf;
      //      printf("read %3.2f\n",tempf);
    }
  }

  // second-order
  for(int j=0; j<4; j++) {
    for(int i=0; i<4; i++) {
      for(int k=0; k<4; k++) {
	ifp2 >> tempf;
	trans[k][4*i+j] = tempf;
	//	printf("I think I'm reading %i-%i in terms of Shirley and saving it here %i\n",j,i,4*i+j);
	//	printf("read %i %i %i %3.2f into %3.2f\n",j,i,k,tempf,trans[k][4*i+j]);
      }
    }
  }

  // third-order
  	for(int j=0; j<4; j++) {
	    for(int i=0; i<4; i++) {
			for(int l=0; l<4; l++) {
	  		    for(int k=0; k<4; k++) {
	  			 	 ifp2 >> tempf;
	  				 trans[k][16*l+4*i+j] = tempf;
  		//printf("I think I'm reading %i-%i in terms of Shirley and saving it here %i\n",j,i,4*i+j);
  		//printf("read %i %i %i %i %3.2f into %3.2f\n",j,i,l,k,tempf,trans[k][4*i+j]);
	  		    }
      		}
  	 	}
   }

   int max1 = 0;
   int max2 = 0;

   int temp1;
   int temp2;
   int temp3;
   int weight[4][lengthOfMotif];

   for(int j=0; j<lengthOfMotif; j++)
     for(int i=0; i<4; i++)
       ifp1 >> weight[i][j];


   // algorithm!
   double V[16];
   for(int i=0; i<4; i++)
     for(int k=0; k<4; k++)
       V[i*4+k] = station[i] * first[i*4+k];


  for(int i=0; i<64; i++)
    for(int j=0; j<maxScore +1 ; j++) {
      array1[i][j] = 0.0;
      array2[i][j] = 0.0;
    }

  for(int i=0; i<16; i++) {
	    array1[i][0] = V[i];
  }

  for(int p=0; p<lengthOfMotif;p++){
    for(int i=0; i<64; i++) {
      temp1 = i/16;
      temp2 = i - 16*(i/16);

      for(int j=0; j < 4; j++)
	  for(int k=0; k<(max1+1); k++) {
	     temp3 = k + weight[temp1][p];
	     if(temp3 > max2)
	        max2 = temp3;
	        array2[i][temp3] = array2[i][temp3]
	        + array1[4*temp2+j][k] * trans[temp1][4*temp2+j];
	  }
    }

    for(int i=0; i<64; i++)
      for(int j=0; j<maxScore + 1; j++) {
   		array1[i][j] = array2[i][j];
		array2[i][j] = 0.0;
	  }

    max1 = max2;
  }

  for(int j=0; j<max1+1; j++) {
    for(int i=0;i<64; i++)
      array2[0][j] = array2[0][j] + array1[i][j];
  }

  double dis = 0.0;
  for(int i=max1; i>=0; i--) {
	 dis = dis + array2[0][i];
     printf("%i %20.15f %20.15f\n",i,array2[0][i], dis);
  }

  ifp1.close();
  ifp2.close();

  exit(0);
}





