#!/usr/bin/perl -w

my @files = (shift || die "input file?");

foreach my $file (@files)
{
  print "processing $file...\n";
  
  open(IN,$file) || die;
  open(OUT,">$file.rfa") || die;
  
  my $gene = '0';
  my $seq = 0;
  while(my $line = <IN>) {

    if($line =~ /^\>/ && $gene eq '0') {
      $seq = '';
      ($gene) = ($line =~ /^>(\S+)/);
      next;
    }

    if($line =~ /^\>/) {
      if($seq ne '')
      {
        print OUT ">$gene\n";
        print OUT $seq,"\n";
      }
      $seq = '';
      ($gene) = ($line =~ /^>(\S+)/);
      next;
    }
    
    chomp $line;
    $line =~ s/\r//g;
    chomp $line;
    next if($line eq '');
    
    $seq .= $line;

  }
  close(IN);
 
  print OUT ">$gene\n";
  print OUT $seq,"\n";
  
  close(OUT);
}


